// The code for this widget is cobbled together from a few samples 
// found on Apple's Developer Connection website. In particular, 
// for info on acquiring and parsing an XML feed (this widget uses 
// two of them):
//
//   http://developer.apple.com/internet/webcontent/xmlhttpreq.html
//
// For how to implement scrolling in a, ah, less unattractive style 
// than scrollbars on an iframe:
//
//   http://developer.apple.com/samplecode/Scroller/Scroller.html
// 
// If you have Developer Tools installed (and really, who else would 
// be nosing around in here?) you can also find this file at
//
//   /Developer/Examples/Dashboard/Sample Code/Scroller/
//
// That Stretcher widget gives me some ideas for Version 2!
//
// Finally, while it's not the only way I tested this widget during 
// development, Widgetarium proved to be a valuable means of both 
// testing and also decomposing existing widgets to find out what 
// makes them tick. Not bad for a "beta" release. Find out more at 
//
//    http://projects.gandreas.com/widgetarium/
//
// Copy as much or as little of this as you want, but if you do 
// something cool based on this in any way, consider letting us 
// know about it: software@do-boy.com
//
// Thanks for trying the BPotD widget.
//
// No  2005 Do-Boy Software, use/distribute freely.

var req = new XMLHttpRequest();
var req_desc = new XMLHttpRequest();
var url = "http://www.ubcbotanicalgarden.org/potd/image_feed.xml";
var url_desc = "http://www.ubcbotanicalgarden.org/potd/index.xml";
var defaultCopy = "If you see this, you are not connected to the internet. The Botany Photo of the Day loads directly from the UBC Botanical Garden&rsquo;s website and requires an active internet connection. If you believe you <i>are</i> connected, you can try to <a href=\&rdquo;javascript:setup()\&rdquo;>reload this widget.</a><br /><br />If you still can&rsquo;t connect to the internet, for now please enjoy a look at <em>Lupinus texensis</em> or the Texas Bluebonnet. Named for its color and, it is said, the resemblance of its petal to a woman&rsquo;s sunbonnet, the bluebonnet is the state flower of Texas.<br /><br />(Pearl appears courtesy of Built By Robots.)";

var xml_url = 'http://www.ubcbotanicalgarden.org/potd/index.xml';

$(document).ready(function(){

	loaded();
	$.ajax({
		type:'GET',
		dataType:'xml',
		url: xml_url,
		success:function(data){
			var title = data.getElementsByTagName('item')[0].getElementsByTagName('title')[0].textContent;
			if ( title.length > 32 ) title = title.substring(0,28) + "&hellip;";
			var link = data.getElementsByTagName('item')[0].getElementsByTagName('link')[0].textContent;
			var img = data.getElementsByTagName('item')[0].getElementsByTagName('description')[0].childNodes[0].textContent;
			var imgObj = $(img);
			var src = imgObj.attr('src');
			var desc = data.getElementsByTagName('item')[0].getElementsByTagName('description')[0].childNodes[1].textContent;
			
			setTitle(title,link);
			setImage(src,link);
			setCopy(desc,link);
			}
		});

});

function setup() {
	// put your setup code here...
	var totd_div = document.getElementById("totd");
	calculateAndShowThumb(totd_div);
}

function setCopy(s,l)// string, link
{
	var totd_div = document.getElementById("totd");

	var outcopy = s.replace(/(<a href=["'][^'"]+['"])([^>]+>)/gi,"$1 onClick=\"widget.openURL(this.href);hidePrefs();return false\"$2");
	s = outcopy + '<p><a href="' + l + '?src=widget"onClick="widget.openURL(this.href);hidePrefs();return false;" title="[click for close-up]">Visit site for close-up photo.</a></p>';

	totd_div.innerHTML = s;
	calculateAndShowThumb(totd_div);
}
function setImage(imgTag,link)
{
	var link = "<a href=\"" + link + "?src=widget\" onClick=\"widget.openURL(this.href);hidePrefs();return false\" title=\"[click for close-up]\">";
	$('#potd').html(link + '<img src="'+imgTag+'" width=180 border=0></a>');
	$('#back_pic').html(link+'<img src="'+imgTag+'" width=180 border=0></a>');
}
function setTitle(s,l)
{
//	$('div#title').html('<a href="'+l'" onclick="widget.openURL(this.href);hidePrefs();return false;">' + s + '</a>');
	$('div#title').text(s);
	$('div#title').html('<a href="'+l+'" title="[click for close-up]" onclick="widget.openURL(this.href);hidePrefs();return false;">' + s + '</a>');
}



// everything below here handles showing and flipping to the prefs on the back and back again...
function showPrefs()
{
	var front = document.getElementById("front");
	var back = document.getElementById("back");

	if (window.widget)
	widget.prepareForTransition("ToBack");

	front.style.display="none";
	back.style.display="block";
	document.getElementById("donePrefsButton").display = "block";

	if (window.widget)
	setTimeout ('widget.performTransition();', 0);
}

function hidePrefs()
{
	var front = document.getElementById("front");
	var back = document.getElementById("back");

	if (window.widget)
	widget.prepareForTransition("ToFront");

	back.style.display="none";
	document.getElementById("donePrefsButton").display = "none";
	front.style.display="block";

	if (window.widget)
	setTimeout ('widget.performTransition();', 0);
}

function enterflip(event)
{
	document.getElementById('fliprollie').style.display = 'block';
}
function exitflip(event)
{
	document.getElementById('fliprollie').style.display = 'none';
}

var flipShown = false;
var animation = {duration:0, starttime:0, to:1.0, now:0.0, from:0.0, firstElement:null, timer:null};
function mousemove (event)
{
	if (!flipShown)
	{
	if (animation.timer != null)
	{
		clearInterval (animation.timer);
		animation.timer	 = null;
	}

	var starttime = (new Date).getTime() - 13;

	animation.duration = 500;
	animation.starttime = starttime;
	animation.firstElement = document.getElementById ('flip');
	animation.timer = setInterval ("animate();", 13);
	animation.from = animation.now;
	animation.to = 1.0;
	animate();
	flipShown = true;
	}
}
function mouseexit (event)
{
	if (flipShown)
	{
	// fade in the info button
	if (animation.timer != null)
	{
		clearInterval (animation.timer);
		animation.timer	 = null;
	}

	var starttime = (new Date).getTime() - 13;

	animation.duration = 500;
	animation.starttime = starttime;
	animation.firstElement = document.getElementById ('flip');
	animation.timer = setInterval ("animate();", 13);
	animation.from = animation.now;
	animation.to = 0.0;
	animate();
	flipShown = false;
	}
}
function animate()
{
	var T;
	var ease;
	var time = (new Date).getTime();

	T = limit_3(time-animation.starttime, 0, animation.duration);

	if (T >= animation.duration)
	{
	clearInterval (animation.timer);
	animation.timer = null;
	animation.now = animation.to;
	}
	else
	{
	ease = 0.5 - (0.5 * Math.cos(Math.PI * T / animation.duration));
	animation.now = computeNextFloat (animation.from, animation.to, ease);
	}

	animation.firstElement.style.opacity = animation.now;
}
function limit_3 (a, b, c)
{
	return a < b ? b : (a > c ? c : a);
}
function computeNextFloat (from, to, ease)
{
	return from + (to - from) * ease;
}
